package hmac_test

import (
	"encoding/hex"
	"fmt"
	"testing"

	"xdx.jelly/xgcl/mac/hmac"
)

var key, _ = hex.DecodeString("000102030405060708090a0b0c0d0e0f")
var data = []byte("Hello")
var hmacTests = []struct {
	hashAlg     string
	tagSize     uint32
	key         []byte
	data        []byte
	expectedMac string
}{
	{
		hashAlg:     "SHA256",
		tagSize:     32,
		data:        data,
		key:         key,
		expectedMac: "e0ff02553d9a619661026c7aa1ddf59b7b44eac06a9908ff9e19961d481935d4",
	},
	{
		hashAlg: "SHA512",
		tagSize: 64,
		data:    data,
		key:     key,
		expectedMac: "481e10d823ba64c15b94537a3de3f253c16642451ac45124dd4dde120bf1e5c15" +
			"e55487d55ba72b43039f235226e7954cd5854b30abc4b5b53171a4177047c9b",
	},
	// empty data
	{
		hashAlg:     "SHA256",
		tagSize:     32,
		data:        []byte{},
		key:         key,
		expectedMac: "07eff8b326b7798c9ccfcbdbe579489ac785a7995a04618b1a2813c26744777d",
	},
	{
		hashAlg:     "SM3",
		tagSize:     32,
		data:        data,
		key:         key,
		expectedMac: "06d19e9ee3a3db273490fb6cf15d001fc3a9dfa9288f4dd801c60f9c8176b8ab",
	},
}

func TestHMACBasic(t *testing.T) {
	for i, test := range hmacTests {
		cipher, err := hmac.NewHMAC(test.hashAlg, test.key, test.tagSize)
		if err != nil {
			t.Errorf("cannot create new mac in test case %d: %s", i, err)
		}
		mac, err := cipher.ComputeMAC(test.data)
		if err != nil {
			t.Errorf("mac computation failed in test case %d: %s", i, err)
		}
		if hex.EncodeToString(mac) != test.expectedMac[:(test.tagSize*2)] {
			t.Errorf("incorrect mac in test case %d: expect %s, got %s",
				i, test.expectedMac[:(test.tagSize*2)], hex.EncodeToString(mac))
		}
		if err := cipher.VerifyMAC(mac, test.data); err != nil {
			t.Errorf("mac verification failed in test case %d: %s", i, err)
		}
	}
}

// 密钥= EFC0D9722E2F539C52E1B40E2F20E73D
// IV= C06B0C0A5295E37A6839EF67CBDA1A2C
// 明文长度= 16
// 明文= 7685B2CE7A74A215E3A4788D50CA6197
// MAC值= BCA3412199BA34A85FAE161AC054B8A5715D4BE6FB302B1C445D056A82EBC140
func TestHMAC(t *testing.T) {
	var key, _ = hex.DecodeString("C62BB9801E85FF7C4CCAEC6152C2E0D4")
	var data, _ = hex.DecodeString("476670281EC8B07402DD3664A3AE83028F251890F408AFE4CBC7FF9DA554EE813A9ECC953299E765ED2597D734226706E54785BCB3671DD908D40C4DCF70985B7B729974EFC71E49251DB5A3501F7A82")
	cipher, err := hmac.NewHMAC("SM3", key, 32)
	if err != nil {
		t.Errorf("cannot create new mac in test case: %s", err)
	}
	mac, err := cipher.ComputeMAC(data)
	if err != nil {
		t.Errorf("mac computation failed in test case: %s", err)
	}
	fmt.Printf("mac: %02x\n", mac)
	// if hex.EncodeToString(mac) != test.expectedMac[:(test.tagSize*2)] {
	// 	t.Errorf("incorrect mac in test case %d: expect %s, got %s",
	// 		i, test.expectedMac[:(test.tagSize*2)], hex.EncodeToString(mac))
	// }
	// if err := cipher.VerifyMAC(mac, test.data); err != nil {
	// 	t.Errorf("mac verification failed in test case %d: %s", i, err)
	// }
}

func TestHMAC2(t *testing.T) {
	var key, _ = hex.DecodeString("12345678901234561234567890123456")
	var data, _ = hex.DecodeString("123456789012345612345678901234560102")
	cipher, err := hmac.NewHMAC("SM3", key, 32)
	if err != nil {
		t.Errorf("cannot create new mac in test case: %s", err)
	}
	mac, err := cipher.ComputeMAC(data)
	if err != nil {
		t.Errorf("mac computation failed in test case: %s", err)
	}
	fmt.Printf("mac: %02x\n", mac)
	// if hex.EncodeToString(mac) != test.expectedMac[:(test.tagSize*2)] {
	// 	t.Errorf("incorrect mac in test case %d: expect %s, got %s",
	// 		i, test.expectedMac[:(test.tagSize*2)], hex.EncodeToString(mac))
	// }
	// if err := cipher.VerifyMAC(mac, test.data); err != nil {
	// 	t.Errorf("mac verification failed in test case %d: %s", i, err)
	// }
}
